libimobiledevice: libimobiledevice/sbservices.h File Reference

libimobiledevice 1.3.0

Macros | Enumerations
sbservices.h File Reference

Manage SpringBoard icons and retrieve icon images. More...

## Macros
#define | SBSERVICES_SERVICE_NAME "com.apple.springboardservices"

## Enumerations
enum | sbservices_error_t { SBSERVICES_E_SUCCESS = 0, SBSERVICES_E_INVALID_ARG = -1, SBSERVICES_E_PLIST_ERROR = -2, SBSERVICES_E_CONN_FAILED = -3, SBSERVICES_E_UNKNOWN_ERROR = -256 }
| Error Codes.

## Orientation of the user interface on the device
enum | sbservices_interface_orientation_t { SBSERVICES_INTERFACE_ORIENTATION_UNKNOWN = 0, SBSERVICES_INTERFACE_ORIENTATION_PORTRAIT = 1, SBSERVICES_INTERFACE_ORIENTATION_PORTRAIT_UPSIDE_DOWN = 2, SBSERVICES_INTERFACE_ORIENTATION_LANDSCAPE_RIGHT = 3, SBSERVICES_INTERFACE_ORIENTATION_LANDSCAPE_LEFT = 4 }
typedef struct sbservices_client_private | sbservices_client_private
typedef sbservices_client_private * | sbservices_client_t
| The client handle.
sbservices_error_t | sbservices_client_new (idevice_t device, lockdownd_service_descriptor_t service, sbservices_client_t *client)
| Connects to the springboardservices service on the specified device. More...
sbservices_error_t | sbservices_client_start_service (idevice_t device, sbservices_client_t *client, const char *label)
| Starts a new sbservices service on the specified device and connects to it. More...
sbservices_error_t | sbservices_client_free (sbservices_client_t client)
| Disconnects an sbservices client from the device and frees up the sbservices client data. More...
sbservices_error_t | sbservices_get_icon_state (sbservices_client_t client, plist_t *state, const char *format_version)
| Gets the icon state of the connected device. More...
sbservices_error_t | sbservices_set_icon_state (sbservices_client_t client, plist_t newstate)
| Sets the icon state of the connected device. More...
sbservices_error_t | sbservices_get_icon_pngdata (sbservices_client_t client, const char *bundleId, char **pngdata, uint64_t *pngsize)
| Get the icon of the specified app as PNG data. More...
sbservices_error_t | sbservices_get_interface_orientation (sbservices_client_t client, sbservices_interface_orientation_t *interface_orientation)
| Gets the interface orientation of the device. More...
sbservices_error_t | sbservices_get_home_screen_wallpaper_pngdata (sbservices_client_t client, char **pngdata, uint64_t *pngsize)
| Get the home screen wallpaper as PNG data. More...

## Detailed Description

Manage SpringBoard icons and retrieve icon images.

## Function Documentation

## ◆ sbservices_client_free()

sbservices_error_t sbservices_client_free | ( | sbservices_client_t | client | ) |

Disconnects an sbservices client from the device and frees up the sbservices client data.

Parameters

  client | The sbservices client to disconnect and free.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client is NULL, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_client_new()

sbservices_error_t sbservices_client_new | ( | idevice_t | device,
|  | lockdownd_service_descriptor_t | service,
|  | sbservices_client_t * | client
| ) |  |

Connects to the springboardservices service on the specified device.

Parameters

  device | The device to connect to.
  service | The service descriptor returned by lockdownd_start_service.
  client | Pointer that will point to a newly allocated sbservices_client_t upon successful return.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client is NULL, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_client_start_service()

sbservices_error_t sbservices_client_start_service | ( | idevice_t | device,
|  | sbservices_client_t * | client,
|  | const char * | label
| ) |  |

Starts a new sbservices service on the specified device and connects to it.

Parameters

  device | The device to connect to.
  client | Pointer that will point to a newly allocated sbservices_client_t upon successful return. Must be freed using sbservices_client_free() after use.
  label | The label to use for communication. Usually the program name. Pass NULL to disable sending the label in requests to lockdownd.

Returns
  SBSERVICES_E_SUCCESS on success, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_get_home_screen_wallpaper_pngdata()

sbservices_error_t sbservices_get_home_screen_wallpaper_pngdata | ( | sbservices_client_t | client,
|  | char ** | pngdata,
|  | uint64_t * | pngsize
| ) |  |

Get the home screen wallpaper as PNG data.

Parameters

  client | The connected sbservices client to use.
  pngdata | Pointer that will point to a newly allocated buffer containing the PNG data upon successful return. It is up to the caller to free the memory.
  pngsize | Pointer to a uint64_t that will be set to the size of the buffer pngdata points to upon successful return.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client or pngdata are invalid, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_get_icon_pngdata()

sbservices_error_t sbservices_get_icon_pngdata | ( | sbservices_client_t | client,
|  | const char * | bundleId,
|  | char ** | pngdata,
|  | uint64_t * | pngsize
| ) |  |

Get the icon of the specified app as PNG data.

Parameters

  client | The connected sbservices client to use.
  bundleId | The bundle identifier of the app to retrieve the icon for.
  pngdata | Pointer that will point to a newly allocated buffer containing the PNG data upon successful return. It is up to the caller to free the memory.
  pngsize | Pointer to a uint64_t that will be set to the size of the buffer pngdata points to upon successful return.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client, bundleId, or pngdata are invalid, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_get_icon_state()

sbservices_error_t sbservices_get_icon_state | ( | sbservices_client_t | client,
|  | plist_t * | state,
|  | const char * | format_version
| ) |  |

Gets the icon state of the connected device.

Parameters

  client | The connected sbservices client to use.
  state | Pointer that will point to a newly allocated plist containing the current icon state. It is up to the caller to free the memory.
  format_version | A string to be passed as formatVersion along with the request, or NULL if no formatVersion should be passed. This is only supported since iOS 4.0 so for older firmware versions this must be set to NULL.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client or state is invalid, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_get_interface_orientation()

sbservices_error_t sbservices_get_interface_orientation | ( | sbservices_client_t | client,
|  | sbservices_interface_orientation_t * | interface_orientation
| ) |  |

Gets the interface orientation of the device.

Parameters

  client | The connected sbservices client to use.
  interface_orientation | The interface orientation upon successful return.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client or state is invalid, or an SBSERVICES_E_* error code otherwise.

## ◆ sbservices_set_icon_state()

sbservices_error_t sbservices_set_icon_state | ( | sbservices_client_t | client,
|  | plist_t | newstate
| ) |  |

Sets the icon state of the connected device.

Parameters

  client | The connected sbservices client to use.
  newstate | A plist containing the new iconstate.

Returns
  SBSERVICES_E_SUCCESS on success, SBSERVICES_E_INVALID_ARG when client or newstate is NULL, or an SBSERVICES_E_* error code otherwise.